/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 18-1 */

 1 #include <sys/stat.h>
 2 #include <fcntl.h>
 3 #include "tlpi_hdr.h"
 4
 5 #define CMD_SIZE 200
 6 #define BUF_SIZE 1024
 7
 8 int
 9 main(int argc, char *argv[])
10 {
11     int fd, j, numBlocks;
12     char shellCmd[CMD_SIZE];            /* Command to be passed to system() */
13     char buf[BUF_SIZE];                 /* Random bytes to write to file */
14
15     if (argc < 2 || strcmp(argv[1], "--help") == 0)
16         usageErr("%s temp-file [num-1kB-blocks] \n", argv[0]);
17
18     numBlocks = (argc > 2) ? getInt(argv[2], GN_GT_0, "num-1kB-blocks")
19                            : 100000;
20
21     fd = open(argv[1], O_WRONLY | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR);
22     if (fd == -1)
23         errExit("open");
24
25     if (unlink(argv[1]) == -1)          /* Remove filename */
26         errExit("unlink");
27
28     for (j = 0; j < numBlocks; j++)     /* Write lots of junk to file */
29         if (write(fd, buf, BUF_SIZE) != BUF_SIZE)
30             fatal("partial/failed write");
31
32     snprintf(shellCmd, CMD_SIZE, "df -k `dirname %s`", argv[1]);
33     system(shellCmd);                   /* View space used in file system */
34
35     if (close(fd) == -1)                /* File is now destroyed */
36         errExit("close");
37     printf("********** Closed file descriptor\n");
38
39     system(shellCmd);                   /* Review space used in file system */
40     exit(EXIT_SUCCESS);
41 }
