/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 18-4 */

 1 #include <sys/stat.h>
 2 #include <limits.h>             /* For definition of PATH_MAX */
 3 #include "tlpi_hdr.h"
 4
 5 #define BUF_SIZE PATH_MAX
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     struct stat statbuf;
11     char buf[BUF_SIZE];
12     ssize_t numBytes;
13
14     if (argc != 2 || strcmp(argv[1], "--help") == 0)
15         usageErr("%s pathname\n", argv[0]);
16
17     if (lstat(argv[1], &statbuf) == -1)
18         errExit("lstat");
19
20     if (!S_ISLNK(statbuf.st_mode))
21         fatal("%s is not a symbolic link", argv[1]);
22
23     numBytes = readlink(argv[1], buf, BUF_SIZE - 1);
24     if (numBytes == -1)
25         errExit("readlink");
26     buf[numBytes] = '\0';                       /* Add terminating null byte */
27     printf("readlink: %s --> %s\n", argv[1], buf);
28
29     if (realpath(argv[1], buf) == NULL)
30         errExit("realpath");
31     printf("realpath: %s --> %s\n", argv[1], buf);
32
33     exit(EXIT_SUCCESS);
34 }
