/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 5-1 */

 1 #include <sys/stat.h>
 2 #include <fcntl.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int fd;
 9
10     if (argc < 2 || strcmp(argv[1], "--help") == 0)
11         usageErr("%s file\n", argv[0]);
12
13     fd = open(argv[1], O_WRONLY);       /* Open 1: check if file exists */
14     if (fd != -1) {                     /* Open succeeded */
15         printf("[PID %ld] File \"%s\" already exists\n",
16                 (long) getpid(), argv[1]);
17         close(fd);
18     } else {
19         if (errno != ENOENT) {          /* Failed for unexpected reason */
20             errExit("open");
21         } else {
22             printf("[PID %ld] File \"%s\" doesn't exist yet\n",
23                     (long) getpid(), argv[1]);
24             if (argc > 2) {             /* Delay between check and create */
25                 sleep(5);               /* Suspend execution for 5 seconds */
26                 printf("[PID %ld] Done sleeping\n", (long) getpid());
27             }
28             fd = open(argv[1], O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR);
29             if (fd == -1)
30                 errExit("open");
31
32             printf("[PID %ld] Created file \"%s\" exclusively\n",
33                     (long) getpid(), argv[1]);          /* MAY NOT BE TRUE! */
34         }
35     }
36
37     exit(EXIT_SUCCESS);
38 }
