/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 5-3 */

 1 #define _LARGEFILE64_SOURCE
 2 #include <sys/stat.h>
 3 #include <fcntl.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     int fd;
10     off64_t off;
11
12     if (argc != 3 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s pathname offset\n", argv[0]);
14
15     fd = open64(argv[1], O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);
16     if (fd == -1)
17         errExit("open64");
18
19     off = atoll(argv[2]);
20     if (lseek64(fd, off, SEEK_SET) == -1)
21         errExit("lseek64");
22
23     if (write(fd, "test", 4) == -1)
24         errExit("write");
25     exit(EXIT_SUCCESS);
26 }
