/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 5-6 */

 1 #include <sys/stat.h>
 2 #include <fcntl.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int fd1, fd2, fd3;
 9 #define file "a"
10     char cmd[] = "cat " file "; echo";
11
12     fd1 = open(file, O_RDWR | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
13     if (fd1 == -1)
14         errExit("open fd1");
15     fd2 = dup(fd1);
16     if (fd2 == -1)
17         errExit("dup");
18     fd3 = open(file, O_RDWR);
19     if (fd3 == -1)
20         errExit("open fd3");
21
22     /* 'fd1' and 'fd2' share same open file table entry (and thus file
23        offset). 'fd3' has its own open file table entry, and thus a
24        separate file offset. */
25
26     if (write(fd1, "Hello,", 6) == -1)
27         errExit("write1");
28     system(cmd);
29     if (write(fd2, " world", 6) == -1)
30         errExit("write2");
31     system(cmd);
32     if (lseek(fd2, 0, SEEK_SET) == -1)
33         errExit("lseek");
34     if (write(fd1, "HELLO,", 6) == -1)
35         errExit("write3");
36     system(cmd);
37     if (write(fd3, "Gidday", 6) == -1)
38         errExit("write4");
39     system(cmd);
40
41     if (close(fd1) == -1)
42         errExit("close output");
43     if (close(fd2) == -1)
44         errExit("close output");
45     if (close(fd3) == -1)
46         errExit("close output");
47     exit(EXIT_SUCCESS);
48 }
