 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Listing 15-4 */
12
13  1 #include <sys/stat.h>
14  2 #include <stdio.h>
15  3 #include "file_perms.h"                 /* Interface for this implementation */
16  4
17  5 #define STR_SIZE sizeof("rwxrwxrwx")
18  6
19  7 char *          /* Return ls(1)-style string for file permissions mask */
20  8 filePermStr(mode_t perm, int flags)
21  9 {
22 10     static char str[STR_SIZE];
23 11
24 12     snprintf(str, STR_SIZE, "%c%c%c%c%c%c%c%c%c",
25 13         (perm & S_IRUSR) ? 'r' : '-', (perm & S_IWUSR) ? 'w' : '-',
26 14         (perm & S_IXUSR) ?
27 15             (((perm & S_ISUID) && (flags & FP_SPECIAL)) ? 's' : 'x') :
28 16             (((perm & S_ISUID) && (flags & FP_SPECIAL)) ? 'S' : '-'),
29 17         (perm & S_IRGRP) ? 'r' : '-', (perm & S_IWGRP) ? 'w' : '-',
30 18         (perm & S_IXGRP) ?
31 19             (((perm & S_ISGID) && (flags & FP_SPECIAL)) ? 's' : 'x') :
32 20             (((perm & S_ISGID) && (flags & FP_SPECIAL)) ? 'S' : '-'),
33 21         (perm & S_IROTH) ? 'r' : '-', (perm & S_IWOTH) ? 'w' : '-',
34 22         (perm & S_IXOTH) ?
35 23             (((perm & S_ISVTX) && (flags & FP_SPECIAL)) ? 't' : 'x') :
36 24             (((perm & S_ISVTX) && (flags & FP_SPECIAL)) ? 'T' : '-'));
37 25
38 26     return str;
39 27 }
