/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 15 */

 1 #include <sys/stat.h>
 2 #include <sys/time.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     struct stat sb;
 9     struct timeval tv[2];
10
11     if (argc != 2 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s file\n", argv[0]);
13
14     if (stat(argv[1], &sb) == -1)       /* Retrieve current file times */
15         errExit("stat");
16
17     tv[0].tv_sec = sb.st_atime;         /* Leave atime seconds unchanged */
18     tv[0].tv_usec = 223344;             /* Change microseconds for atime */
19     tv[1].tv_sec = sb.st_atime;         /* mtime seconds == atime seconds */
20     tv[1].tv_usec = 667788;             /* mtime microseconds */
21
22     if (utimes(argv[1], tv) == -1)
23         errExit("utimes");
24
25     exit(EXIT_SUCCESS);
26 }
