/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 14 */

 1 #include <sys/statfs.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     struct statfs sfs;
 8
 9     if (argc != 2 || strcmp(argv[1], "--help") == 0)
10         usageErr("%s path\n", argv[0]);
11
12     if (statfs(argv[1], &sfs) == -1)
13         errExit("statfs");
14
15     printf("File system type:              %#lx\n",
16             (unsigned long) sfs.f_type);
17     printf("Optimal I/O block size:        %lu\n",
18             (unsigned long) sfs.f_bsize);
19     printf("Total data blocks:             %lu\n",
20             (unsigned long) sfs.f_blocks);
21     printf("Free data blocks:              %lu\n",
22             (unsigned long) sfs.f_bfree);
23     printf("Free blocks for nonsuperuser:  %lu\n",
24             (unsigned long) sfs.f_bavail);
25     printf("Total i-nodes:                 %lu\n",
26             (unsigned long) sfs.f_files);
27     printf("File system ID:                %#x, %#x\n",
28             (unsigned) sfs.f_fsid.__val[0], (unsigned) sfs.f_fsid.__val[1]);
29     printf("Free i-nodes:                  %lu\n",
30             (unsigned long) sfs.f_ffree);
31     printf("Maximum file name length:      %lu\n",
32             (unsigned long) sfs.f_namelen);
33
34     exit(EXIT_SUCCESS);
35 }
