/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 14 */

 1 #include <sys/statvfs.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     struct statvfs sb;
 8
 9     if (argc != 2 || strcmp(argv[1], "--help") == 0)
10         usageErr("%s path\n", argv[0]);
11
12     if (statvfs(argv[1], &sb) == -1)
13         errExit("statvfs");
14
15     printf("Block size                       %lu\n", sb.f_bsize);
16     printf("Fundamental block size           %lu\n", sb.f_frsize);
17     printf("Total blocks (in above units)    %lu\n",
18             (unsigned long) sb.f_blocks);
19     printf("Free blocks for priv. proc.      %lu\n",
20             (unsigned long) sb.f_bfree);
21     printf("Free blocks for unpriv. proc.    %lu\n",
22             (unsigned long) sb.f_bavail);
23     printf("Total number of i-nodes          %lu\n",
24             (unsigned long) sb.f_files);
25     printf("Free i-nodes for priv. proc.     %lu\n",
26             (unsigned long) sb.f_ffree);
27     printf("Free i-nodes for nonpriv. proc.  %lu\n",
28             (unsigned long) sb.f_favail);
29     printf("File system ID                   %#lx\n", sb.f_fsid);
30     printf("Flags                            %#lx\n", sb.f_flag);
31     printf("Maximum filename length          %lu\n", sb.f_namemax);
32
33     exit(EXIT_SUCCESS);
34 }
