 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10 
11 /* Listing 37-1 */
12 
13  1 #ifndef BECOME_DAEMON_H             /* Prevent double inclusion */
14  2 #define BECOME_DAEMON_H
15  3
16  4 /* Bit-mask values for 'flags' argument of becomeDaemon() */
17  5
18  6 #define BD_NO_CHDIR           01    /* Don't chdir("/") */
19  7 #define BD_NO_CLOSE_FILES     02    /* Don't close all open files */
20  8 #define BD_NO_REOPEN_STD_FDS  04    /* Don't reopen stdin, stdout, and
21  9                                        stderr to /dev/null */
22 10 #define BD_NO_UMASK0         010    /* Don't do a umask(0) */
23 11
24 12 #define BD_MAX_CLOSE  8192          /* Maximum file descriptors to close if
25 13                                        sysconf(_SC_OPEN_MAX) is indeterminate */
26 14
27 15 int becomeDaemon(int flags);
28 16
29 17 #endif
