/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Lesser General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
\*************************************************************************/

/* Listing 3-5 */

 1 #ifndef GET_NUM_H
 2 #define GET_NUM_H
 3 
 4 #define GN_NONNEG       01      /* Value must be >= 0 */
 5 #define GN_GT_0         02      /* Value must be > 0 */
 6 
 7                                 /* By default, integers are decimal */
 8 #define GN_ANY_BASE   0100      /* Can use any base - like strtol(3) */
 9 #define GN_BASE_8     0200      /* Value is expressed in octal */
10 #define GN_BASE_16    0400      /* Value is expressed in hexadecimal */
11 
12 long getLong(const char *arg, int flags, const char *name);
13 
14 int getInt(const char *arg, int flags, const char *name);
15 
16 #endif
