 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10 
11 /* Listing 59-8 */
12 
13  1 #ifndef INET_SOCKETS_H
14  2 #define INET_SOCKETS_H          /* Prevent accidental double inclusion */
15  3
16  4 #include <sys/socket.h>
17  5 #include <netdb.h>
18  6
19  7 int inetConnect(const char *host, const char *service, int type);
20  8
21  9 int inetListen(const char *service, int backlog, socklen_t *addrlen);
22 10
23 11 int inetBind(const char *service, int type, socklen_t *addrlen);
24 12
25 13 char *inetAddressStr(const struct sockaddr *addr, socklen_t addrlen,
26 14                 char *addrStr, int addrStrLen);
27 15
28 16 #define IS_ADDR_STR_LEN 4096
29 17                         /* Suggested length for string buffer that caller
30 18                            should pass to inetAddressStr(). Must be greater
31 19                            than (NI_MAXHOST + NI_MAXSERV + 4) */
32 20 #endif
