 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Listing 22-1 */
12
13  1 #include <signal.h>
14  2
15  3 typedef void (*sighandler_t)(int);
16  4
17  5 sighandler_t
18  6 signal(int sig, sighandler_t handler)
19  7 {
20  8     struct sigaction newDisp, prevDisp;
21  9
22 10     newDisp.sa_handler = handler;
23 11     sigemptyset(&newDisp.sa_mask);
24 12 #ifdef OLD_SIGNAL
25 13     newDisp.sa_flags = SA_RESETHAND | SA_NODEFER;
26 14 #else
27 15     newDisp.sa_flags = SA_RESTART;
28 16 #endif
29 17
30 18     if (sigaction(sig, &newDisp, &prevDisp) == -1)
31 19         return SIG_ERR;
32 20     else
33 21         return prevDisp.sa_handler;
34 22 }
