/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Lesser General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
\*************************************************************************/

/* Listing 3-1 */

 1 #ifndef TLPI_HDR_H
 2 #define TLPI_HDR_H      /* Prevent accidental double inclusion */
 3 
 4 #include <sys/types.h>  /* Type definitions used by many programs */
 5 #include <stdio.h>      /* Standard I/O functions */
 6 #include <stdlib.h>     /* Prototypes of commonly used library functions,
 7                            plus EXIT_SUCCESS and EXIT_FAILURE constants */
 8 #include <unistd.h>     /* Prototypes for many system calls */
 9 #include <errno.h>      /* Declares errno and defines error constants */
10 #include <string.h>     /* Commonly used string-handling functions */
11 
12 #include "get_num.h"    /* Declares our functions for handling numeric
13                            arguments (getInt(), getLong()) */
14 
15 #include "error_functions.h"  /* Declares our error-handling functions */
16 
17 typedef enum { FALSE, TRUE } Boolean;
18 
19 #define min(m,n) ((m) < (n) ? (m) : (n))
20 #define max(m,n) ((m) > (n) ? (m) : (n))
21 
22 #endif
