/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 40-2 */

 1 #define _GNU_SOURCE
 2 #include <time.h>
 3 #include <utmpx.h>
 4 #include <paths.h>
 5 #include "tlpi_hdr.h"
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     struct utmpx *ut;
11
12     if (argc > 1 && strcmp(argv[1], "--help") == 0)
13         usageErr("%s [utmp-pathname]\n", argv[0]);
14
15     if (argc > 1)               /* Use alternate file if supplied */
16         if (utmpxname(argv[1]) == -1)
17             errExit("utmpxname");
18
19     setutxent();
20
21     printf("user     type        PID line   id  host      date/time\n");
22
23     while ((ut = getutxent()) != NULL) {        /* Sequential scan to EOF */
24         printf("%-8s ", ut->ut_user);
25         printf("%-9.9s ",
26                 (ut->ut_type == EMPTY) ?         "EMPTY" :
27                 (ut->ut_type == RUN_LVL) ?       "RUN_LVL" :
28                 (ut->ut_type == BOOT_TIME) ?     "BOOT_TIME" :
29                 (ut->ut_type == NEW_TIME) ?      "NEW_TIME" :
30                 (ut->ut_type == OLD_TIME) ?      "OLD_TIME" :
31                 (ut->ut_type == INIT_PROCESS) ?  "INIT_PR" :
32                 (ut->ut_type == LOGIN_PROCESS) ? "LOGIN_PR" :
33                 (ut->ut_type == USER_PROCESS) ?  "USER_PR" :
34                 (ut->ut_type == DEAD_PROCESS) ?  "DEAD_PR" : "???");
35         printf("%5ld %-6.6s %-3.5s %-9.9s ", (long) ut->ut_pid,
36                 ut->ut_line, ut->ut_id, ut->ut_host);
37         printf("%s", ctime((time_t *) &(ut->ut_tv.tv_sec)));
38     }
39
40     endutxent();
41     exit(EXIT_SUCCESS);
42 }
