/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 49-1 */

 1 #include <sys/mman.h>
 2 #include <sys/stat.h>
 3 #include <fcntl.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     char *addr;
10     int fd;
11     struct stat sb;
12
13     if (argc != 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s file\n", argv[0]);
15
16     fd = open(argv[1], O_RDONLY);
17     if (fd == -1)
18         errExit("open");
19
20     /* Obtain the size of the file and use it to specify the size of
21        the mapping and the size of the buffer to be written */
22
23     if (fstat(fd, &sb) == -1)
24         errExit("fstat");
25
26     addr = mmap(NULL, sb.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
27     if (addr == MAP_FAILED)
28         errExit("mmap");
29
30     if (write(STDOUT_FILENO, addr, sb.st_size) != sb.st_size)
31         fatal("partial/failed write");
32     exit(EXIT_SUCCESS);
33 }
