/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 49-2 */

 1 #include <sys/mman.h>
 2 #include <fcntl.h>
 3 #include "tlpi_hdr.h"
 4
 5 #define MEM_SIZE 10
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     char *addr;
11     int fd;
12
13     if (argc < 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s file [new-value]\n", argv[0]);
15
16     fd = open(argv[1], O_RDWR);
17     if (fd == -1)
18         errExit("open");
19
20     addr = mmap(NULL, MEM_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
21     if (addr == MAP_FAILED)
22         errExit("mmap");
23
24     if (close(fd) == -1)                /* No longer need 'fd' */
25         errExit("close");
26
27     printf("Current string=%.*s\n", MEM_SIZE, addr);
28                         /* Secure practice: output at most MEM_SIZE bytes */
29
30     if (argc > 2) {                     /* Update contents of region */
31         if (strlen(argv[2]) >= MEM_SIZE)
32             cmdLineErr("'new-value' too large\n");
33
34         memset(addr, 0, MEM_SIZE);      /* Zero out region */
35         strncpy(addr, argv[2], MEM_SIZE - 1);
36         if (msync(addr, MEM_SIZE, MS_SYNC) == -1)
37             errExit("msync");
38
39         printf("Copied \"%s\" to shared memory\n", argv[2]);
40     }
41
42     exit(EXIT_SUCCESS);
43 }
