/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 49 */

 1 #define _GNU_SOURCE             /* Get remap_file_pages() declaration
 2                                    from <sys/mman.h> */
 3 #include <sys/stat.h>
 4 #include <fcntl.h>
 5 #include <sys/mman.h>
 6 #include "tlpi_hdr.h"
 7
 8 int
 9 main(int argc, char *argv[])
10 {
11     int fd, j;
12     char ch;
13     long pageSize;
14     char *addr;
15
16     fd = open("/tmp/tfile", O_CREAT | O_TRUNC | O_RDWR, S_IRUSR | S_IWUSR);
17     if (fd == -1)
18         errExit("open");
19
20     pageSize = sysconf(_SC_PAGESIZE);
21     if (pageSize == -1)
22         fatal("Couldn't determine page size");
23
24     for (ch = 'a'; ch < 'd'; ch++)
25         for (j = 0; j < pageSize; j++)
26             write(fd, &ch, 1);
27
28     system("od -a /tmp/tfile");
29
30     addr = mmap(0, 3 * pageSize, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
31     if (addr == MAP_FAILED)
32         errExit("mmap");
33
34     printf("Mapped at address %p\n", addr);
35
36     /* The three pages of the file -- 0 1 2 -- are currently mapped
37        linearly. Now we rearrange the mapping to 2 1 0. */
38
39     if (remap_file_pages(addr, pageSize, 0, 2, 0) == -1)
40         errExit("remap_file_pages");
41     if (remap_file_pages(addr + 2 * pageSize, pageSize, 0, 0, 0) == -1)
42         errExit("remap_file_pages");
43
44     /* Now we modify the contents of the mapping */
45
46     for (j = 0; j < 0x100; j++)         /* Modifies page 2 of file */
47         *(addr + j) = '0';
48     for (j = 0; j < 0x100; j++)         /* Modifies page 0 of file */
49         *(addr + 2 * pageSize + j) = '2';
50
51     system("od -a /tmp/tfile");
52
53     exit(EXIT_SUCCESS);
54 }
