/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 52-3 */

 1 #include <mqueue.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     mqd_t mqd;
 8     struct mq_attr attr;
 9
10     if (argc != 2 || strcmp(argv[1], "--help") == 0)
11         usageErr("%s mq-name\n", argv[0]);
12
13     mqd = mq_open(argv[1], O_RDONLY);
14     if (mqd == (mqd_t) -1)
15         errExit("mq_open");
16
17     if (mq_getattr(mqd, &attr) == -1)
18         errExit("mq_getattr");
19
20     printf("Maximum # of messages on queue:   %ld\n", attr.mq_maxmsg);
21     printf("Maximum message size:             %ld\n", attr.mq_msgsize);
22     printf("# of messages currently on queue: %ld\n", attr.mq_curmsgs);
23     exit(EXIT_SUCCESS);
24 }
