/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 25-1 */

 1 #define _BSD_SOURCE     /* Get on_exit() declaration from <stdlib.h> */
 2 #include <stdlib.h>
 3 #include "tlpi_hdr.h"
 4
 5 static void
 6 atexitFunc1(void)
 7 {
 8     printf("atexit function 1 called\n");
 9 }
10
11 static void
12 atexitFunc2(void)
13 {
14     printf("atexit function 2 called\n");
15 }
16
17 static void
18 onexitFunc(int exitStatus, void *arg)
19 {
20     printf("on_exit function called: status=%d, arg=%ld\n",
21                 exitStatus, (long) arg);
22 }
23
24 int
25 main(int argc, char *argv[])
26 {
27     if (on_exit(onexitFunc, (void *) 10) != 0)
28         fatal("on_exit 1");
29     if (atexit(atexitFunc1) != 0)
30         fatal("atexit 1");
31     if (atexit(atexitFunc2) != 0)
32         fatal("atexit 2");
33     if (on_exit(onexitFunc, (void *) 20) != 0)
34         fatal("on_exit 2");
35
36     exit(2);
37 }
