/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 24-3 */

 1 #define _BSD_SOURCE     /* To get sbrk() declaration from <unistd.h> in case
 2                            _XOPEN_SOURCE >= 600; defining _SVID_SOURCE or
 3                            _GNU_SOURCE also suffices */
 4 #include <sys/wait.h>
 5 #include "tlpi_hdr.h"
 6
 7 static int
 8 func(int arg)
 9 {
10     int j;
11
12     for (j = 0; j < 0x100; j++)
13         if (malloc(0x8000) == NULL)
14             errExit("malloc");
15     printf("Program break in child:  %10p\n", sbrk(0));
16
17     return arg;
18 }
19
20 int
21 main(int argc, char *argv[])
22 {
23     int arg = (argc > 1) ? getInt(argv[1], 0, "arg") : 0;
24     pid_t childPid;
25     int status;
26
27     setbuf(stdout, NULL);           /* Disable buffering of stdout */
28
29     printf("Program break in parent: %10p\n", sbrk(0));
30
31     childPid = fork();
32     if (childPid == -1)
33         errExit("fork");
34
35     if (childPid == 0)              /* Child calls func() and */
36         exit(func(arg));            /* uses return value as exit status */
37
38     /* Parent waits for child to terminate. It can determine the
39        result of func() by inspecting 'status' */
40
41     if (wait(&status) == -1)
42         errExit("wait");
43
44     printf("Program break in parent: %10p\n", sbrk(0));
45
46     printf("Status = %d %d\n", status, WEXITSTATUS(status));
47
48     exit(EXIT_SUCCESS);
49 }
