/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 24-5 */

 1 #include <sys/wait.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int numChildren, j;
 8     pid_t childPid;
 9
10     if (argc > 1 && strcmp(argv[1], "--help") == 0)
11         usageErr("%s [num-children]\n", argv[0]);
12
13     numChildren = (argc > 1) ? getInt(argv[1], GN_GT_0, "num-children") : 1;
14
15     setbuf(stdout, NULL);               /* Make stdout unbuffered */
16
17     for (j = 0; j < numChildren; j++) {
18         switch (childPid = fork()) {
19         case -1:
20             errExit("fork");
21
22         case 0:
23             printf("%d child\n", j);
24             _exit(EXIT_SUCCESS);
25
26         default:
27             printf("%d parent\n", j);
28             wait(NULL);                 /* Wait for child to terminate */
29             break;
30         }
31     }
32
33     exit(EXIT_SUCCESS);
34 }
