/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 24-1 */

 1 #include "tlpi_hdr.h"
 2
 3 static int idata = 111;             /* Allocated in data segment */
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int istack = 222;               /* Allocated in stack segment */
 9     pid_t childPid;
10
11     switch (childPid = fork()) {
12     case -1:
13         errExit("fork");
14
15     case 0:
16         idata *= 3;
17         istack *= 3;
18         break;
19
20     default:
21         sleep(3);                   /* Give child a chance to execute */
22         break;
23     }
24
25     /* Both parent and child come here */
26
27     printf("PID=%ld %s idata=%d istack=%d\n", (long) getpid(),
28             (childPid == 0) ? "(child) " : "(parent)", idata, istack);
29
30     exit(EXIT_SUCCESS);
31 }
