/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 24-4 */

 1 #include "tlpi_hdr.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     int istack = 222;
 7
 8     switch (vfork()) {
 9     case -1:
10         errExit("vfork");
11
12     case 0:             /* Child executes first, in parent's memory space */
13         sleep(3);                   /* Even if we sleep for a while,
14                                        parent still is not scheduled */
15         write(STDOUT_FILENO, "Child executing\n", 16);
16         istack *= 3;                /* This change will be seen by parent */
17         _exit(EXIT_SUCCESS);
18
19     default:            /* Parent is blocked until child exits */
20         write(STDOUT_FILENO, "Parent executing\n", 17);
21         printf("istack=%d\n", istack);
22         exit(EXIT_SUCCESS);
23     }
24 }
