/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 24-2 */

 1 #define _BSD_SOURCE     /* To get vfork() declaration from <unistd.h>
 2                            in case _XOPEN_SOURCE >= 700 */
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     switch (vfork()) {
 9     case -1: errExit("vfork");
10
11     case 0: if (close(STDOUT_FILENO) == -1)
12                 errMsg("close - child");
13             _exit(EXIT_SUCCESS);
14
15     default: break;
16     }
17
18     /* Now parent closes STDOUT_FILENO twice: only the second close
19        should fail, indicating that the close(STDOUT_FILENO) by the
20        child did not affect the parent. */
21
22     if (close(STDOUT_FILENO) == -1)
23         errMsg("close");
24     if (close(STDOUT_FILENO) == -1)
25         errMsg("close");
26
27     exit(EXIT_SUCCESS);
28 }
