/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 35-3 */

 1 #include <sched.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int j, pol;
 8     struct sched_param sp;
 9
10     for (j = 1; j < argc; j++) {
11         pol = sched_getscheduler(getLong(argv[j], 0, "pid"));
12         if (pol == -1)
13             errExit("sched_getscheduler");
14
15         if (sched_getparam(getLong(argv[j], 0, "pid"), &sp) == -1)
16             errExit("sched_getparam");
17
18         printf("%s: %-5s ", argv[j],
19                 (pol == SCHED_OTHER) ? "OTHER" :
20                 (pol == SCHED_RR) ? "RR" :
21                 (pol == SCHED_FIFO) ? "FIFO" :
22 #ifdef SCHED_BATCH              /* Linux-specific */
23                 (pol == SCHED_BATCH) ? "BATCH" :
24 #endif
25 #ifdef SCHED_IDLE               /* Linux-specific */
26                 (pol == SCHED_IDLE) ? "IDLE" :
27 #endif
28                 "???");
29         printf("%2d\n", sp.sched_priority);
30     }
31
32     exit(EXIT_SUCCESS);
33 }
