/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 35 */

 1 #define _GNU_SOURCE
 2 #include <sched.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     pid_t pid;
 9     cpu_set_t set;
10     int cpu;
11     unsigned long mask;
12
13     if (argc != 3 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s pid mask\n", argv[0]);
15
16     pid = getInt(argv[1], GN_NONNEG, "pid");
17     mask = getLong(argv[2], GN_ANY_BASE, "octal-mask");
18
19     CPU_ZERO(&set);
20
21     for (cpu = 0; mask > 0; cpu++, mask >>= 1)
22         if (mask & 1)
23             CPU_SET(cpu, &set);
24
25     if (sched_setaffinity(pid, sizeof(set), &set) == -1)
26         errExit("sched_setaffinity");
27
28     exit(EXIT_SUCCESS);
29 }
