/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 42-1 */

 1 #include <dlfcn.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     void *libHandle;            /* Handle for shared library */
 8     void (*funcp)(void);        /* Pointer to function with no arguments */
 9     const char *err;
10
11     if (argc != 3 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s lib-path func-name\n", argv[0]);
13
14     /* Load the shared library and get a handle for later use */
15
16     libHandle = dlopen(argv[1], RTLD_LAZY);
17     if (libHandle == NULL)
18         fatal("dlopen: %s", dlerror());
19
20     /* Search library for symbol named in argv[2] */
21
22     (void) dlerror();                           /* Clear dlerror() */
23     *(void **) (&funcp) = dlsym(libHandle, argv[2]);
24     err = dlerror();
25     if (err != NULL)
26         fatal("dlsym: %s", err);
27
28     /* If the address returned by dlsym() is non-NULL, try calling it
29        as a function that takes no arguments */
30
31     if (funcp == NULL)
32         printf("%s is NULL\n", argv[2]);
33     else
34         (*funcp)();
35
36     dlclose(libHandle);                         /* Close the library */
37
38     exit(EXIT_SUCCESS);
39 }
