/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 22-7 */

 1 #include <sys/signalfd.h>
 2 #include <signal.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     sigset_t mask;
 9     int sfd, j;
10     struct signalfd_siginfo fdsi;
11     ssize_t s;
12
13     if (argc < 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s sig-num...\n", argv[0]);
15
16     printf("%s: PID = %ld\n", argv[0], (long) getpid());
17
18     sigemptyset(&mask);
19     for (j = 1; j < argc; j++)
20         sigaddset(&mask, atoi(argv[j]));
21
22     if (sigprocmask(SIG_BLOCK, &mask, NULL) == -1)
23         errExit("sigprocmask");
24
25     sfd = signalfd(-1, &mask, 0);
26     if (sfd == -1)
27         errExit("signalfd");
28
29     for (;;) {
30         s = read(sfd, &fdsi, sizeof(struct signalfd_siginfo));
31         if (s != sizeof(struct signalfd_siginfo))
32             errExit("read");
33
34         printf("%s: got signal %d", argv[0], fdsi.ssi_signo);
35         if (fdsi.ssi_code == SI_QUEUE) {
36             printf("; ssi_pid = %d; ", fdsi.ssi_pid);
37             printf("ssi_int = %d", fdsi.ssi_int);
38         }
39         printf("\n");
40     }
41 }
