/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 60-2 */

 1 #include <syslog.h>
 2 #include "id_echo.h"
 3 #include "become_daemon.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int sfd;
 9     ssize_t numRead;
10     socklen_t len;
11     struct sockaddr_storage claddr;
12     char buf[BUF_SIZE];
13     char addrStr[IS_ADDR_STR_LEN];
14
15     if (becomeDaemon(0) == -1)
16         errExit("becomeDaemon");
17
18     sfd = inetBind(SERVICE, SOCK_DGRAM, NULL);
19     if (sfd == -1) {
20         syslog(LOG_ERR, "Could not create server socket (%s)", strerror(errno));
21         exit(EXIT_FAILURE);
22     }
23
24     /* Receive datagrams and return copies to senders */
25
26     for (;;) {
27         len = sizeof(struct sockaddr_storage);
28         numRead = recvfrom(sfd, buf, BUF_SIZE, 0,
29                            (struct sockaddr *) &claddr, &len);
30         if (numRead == -1)
31             errExit("recvfrom");
32
33         if (sendto(sfd, buf, numRead, 0, (struct sockaddr *) &claddr, len)
34                         != numRead)
35             syslog(LOG_WARNING, "Error echoing response to %s (%s)",
36                     inetAddressStr((struct sockaddr *) &claddr, len,
37                                    addrStr, IS_ADDR_STR_LEN),
38                     strerror(errno));
39     }
40 }
