/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 61-2 */

 1 #include "inet_sockets.h"
 2 #include "tlpi_hdr.h"
 3
 4 #define BUF_SIZE 100
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     int sfd;
10     ssize_t numRead;
11     char buf[BUF_SIZE];
12
13     if (argc != 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s host\n", argv[0]);
15
16     sfd = inetConnect(argv[1], "echo", SOCK_STREAM);
17     if (sfd == -1)
18         errExit("inetConnect");
19
20     switch (fork()) {
21     case -1:
22         errExit("fork");
23
24     case 0:             /* Child: read server's response, echo on stdout */
25         for (;;) {
26             numRead = read(sfd, buf, BUF_SIZE);
27             if (numRead <= 0)                   /* Exit on EOF or error */
28                 break;
29             printf("%.*s", (int) numRead, buf);
30         }
31         exit(EXIT_SUCCESS);
32
33     default:            /* Parent: write contents of stdin to socket */
34         for (;;) {
35             numRead = read(STDIN_FILENO, buf, BUF_SIZE);
36             if (numRead <= 0)                   /* Exit loop on EOF or error */
37                 break;
38             if (write(sfd, buf, numRead) != numRead)
39                 fatal("write() failed");
40         }
41
42         /* Close writing channel, so server sees EOF */
43
44         if (shutdown(sfd, SHUT_WR) == -1)
45             errExit("shutdown");
46         exit(EXIT_SUCCESS);
47     }
48 }
