 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10 
11 /* Solution for Exercise 59-1:b */
12 
13  1 #ifndef READ_LINE_BUF_H         /* Prevent accidental double inclusion */
14  2 #define READ_LINE_BUF_H
15  3
16  4 #include <unistd.h>
17  5 #include <pthread.h>
18  6 #include <errno.h>
19  7
20  8 #define RL_MAX_BUF 10
21  9
22 10 struct ReadLineBuf {
23 11     int     fd;                 /* File descriptor from which to read */
24 12     char    buf[RL_MAX_BUF];    /* Current buffer from file */
25 13     int     next;               /* Index of next unread character in 'buf' */
26 14     ssize_t len;                /* Number of characters in 'buf' */
27 15 };
28 16
29 17 void readLineBufInit(int fd, struct ReadLineBuf *rlbuf);
30 18
31 19 ssize_t readLineBuf(struct ReadLineBuf *rlbuf, char *buffer, size_t n);
32 20
33 21 #endif
