/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 59-10 */

 1 #define _BSD_SOURCE     /* To get hstrerror() declaration from <netdb.h> */
 2 #include <netdb.h>
 3 #include <netinet/in.h>
 4 #include <arpa/inet.h>
 5 #include "tlpi_hdr.h"
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     struct hostent *h;
11     char **pp;
12     char str[INET6_ADDRSTRLEN];
13
14     for (argv++; *argv != NULL; argv++) {
15         h = gethostbyname(*argv);
16         if (h == NULL) {
17             fprintf(stderr, "gethostbyname() failed for '%s': %s\n",
18                     *argv, hstrerror(h_errno));
19             continue;
20         }
21
22         printf("Canonical name: %s\n", h->h_name);
23
24         printf("        alias(es):     ");
25         for (pp = h->h_aliases; *pp != NULL; pp++)
26             printf(" %s", *pp);
27         printf("\n");
28
29         printf("        address type:   %s\n",
30                 (h->h_addrtype == AF_INET) ? "AF_INET" :
31                 (h->h_addrtype == AF_INET6) ? "AF_INET6" : "???");
32
33         if (h->h_addrtype == AF_INET || h->h_addrtype == AF_INET6) {
34             printf("        address(es):   ");
35             for (pp = h->h_addr_list; *pp != NULL; pp++)
36                 printf(" %s", inet_ntop(h->h_addrtype, *pp,
37                                         str, INET6_ADDRSTRLEN));
38             printf("\n");
39         }
40     }
41
42     exit(EXIT_SUCCESS);
43 }
