/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 59 */

 1 #include <netdb.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     struct servent *s;
 8     char **pp;
 9
10     if (argc < 2 || strcmp(argv[1], "--help") == 0)
11         usageErr("%s service [protocol]\n", argv[0]);
12
13     s = getservbyname(argv[1], argv[2]);
14     if (s == NULL)
15         fatal("getservbyname() could not find a matching record");
16
17     printf("Official name: %s\n", s->s_name);
18     printf("Aliases:      ");
19     for (pp = s->s_aliases; *pp != NULL; pp++)
20         printf(" %s", *pp);
21     printf("\n");
22     printf("Port:          %u\n", ntohs(s->s_port));
23     printf("Protocol:      %s\n", s->s_proto);
24
25     exit(EXIT_SUCCESS);
26 }
