/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 57-7 */

 1 #include "ud_ucase.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     struct sockaddr_un svaddr, claddr;
 7     int sfd, j;
 8     size_t msgLen;
 9     ssize_t numBytes;
10     char resp[BUF_SIZE];
11
12     if (argc < 2 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s msg...\n", argv[0]);
14
15     /* Create client socket; bind to unique pathname (based on PID) */
16
17     sfd = socket(AF_UNIX, SOCK_DGRAM, 0);
18     if (sfd == -1)
19         errExit("socket");
20
21     memset(&claddr, 0, sizeof(struct sockaddr_un));
22     claddr.sun_family = AF_UNIX;
23     snprintf(claddr.sun_path, sizeof(claddr.sun_path),
24             "/tmp/ud_ucase_cl.%ld", (long) getpid());
25
26     if (bind(sfd, (struct sockaddr *) &claddr, sizeof(struct sockaddr_un)) == -1)
27         errExit("bind");
28
29     /* Construct address of server */
30
31     memset(&svaddr, 0, sizeof(struct sockaddr_un));
32     svaddr.sun_family = AF_UNIX;
33     strncpy(svaddr.sun_path, SV_SOCK_PATH, sizeof(svaddr.sun_path) - 1);
34
35     /* Send messages to server; echo responses on stdout */
36
37     for (j = 1; j < argc; j++) {
38         msgLen = strlen(argv[j]);       /* May be longer than BUF_SIZE */
39         if (sendto(sfd, argv[j], msgLen, 0, (struct sockaddr *) &svaddr,
40                 sizeof(struct sockaddr_un)) != msgLen)
41             fatal("sendto");
42
43         numBytes = recvfrom(sfd, resp, BUF_SIZE, 0, NULL, 0);
44         if (numBytes == -1)
45             errExit("recvfrom");
46         printf("Response %d: %.*s\n", j, (int) numBytes, resp);
47     }
48
49     remove(claddr.sun_path);            /* Remove client socket pathname */
50     exit(EXIT_SUCCESS);
51 }
