/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 57-8 */

 1 #include <sys/un.h>
 2 #include <sys/socket.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int sockfd;
 9     struct sockaddr_un addr;
10     char *str;
11
12     memset(&addr, 0, sizeof(struct sockaddr_un));  /* Clear address structure */
13     addr.sun_family = AF_UNIX;                     /* UNIX domain address */
14
15     /* addr.sun_path[0] has already been set to 0 by memset() */
16
17     str = "xyz";        /* Abstract name is "\0abc" */
18     strncpy(&addr.sun_path[1], str, strlen(str));
19
20     sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
21     if (sockfd == -1)
22         errExit("socket");
23
24     if (bind(sockfd, (struct sockaddr *) &addr,
25             sizeof(sa_family_t) + strlen(str) + 1) == -1)
26         errExit("bind");
27
28     sleep(60);
29
30     exit(EXIT_SUCCESS);
31 }
