/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 59-3:d */

 1 #include "us_xfr_v2.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     int sfd, cfd;
 7     ssize_t numRead;
 8     char buf[BUF_SIZE];
 9
10     sfd = unixListen(SV_SOCK_PATH, 5);
11     if (sfd == -1)
12         errExit("unixListen");
13
14     for (;;) {          /* Handle client connections iteratively */
15         cfd = accept(sfd, NULL, 0);
16         if (cfd == -1)
17             errExit("accept");
18
19         /* Transfer data from connected socket to stdout until EOF */
20
21         while ((numRead = read(cfd, buf, BUF_SIZE)) > 0)
22             if (write(STDOUT_FILENO, buf, numRead) != numRead)
23                 fatal("partial/failed write");
24
25         if (numRead == -1)
26             errExit("read");
27         if (close(cfd) == -1)
28             errMsg("close");
29     }
30 }
