/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 45-2 */

 1 #include <sys/ipc.h>
 2 #include <sys/stat.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     key_t key;
 9     struct stat sb;
10
11     if (argc != 3 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s file-name keychar\n", argv[0]);
13
14     printf("Size of key_t = %ld bytes\n", (long) sizeof(key_t));
15
16     if (stat(argv[1], &sb) == -1)
17         errExit("stat");
18
19     key = ftok(argv[1], argv[2][0]);
20     if (key == -1)
21         errExit("ftok");
22
23     printf("Key = %lx i-node = %lx st_dev = %lx proj = %x\n",
24           (unsigned long) key, (unsigned long) sb.st_ino,
25           (unsigned long) sb.st_dev, (unsigned int) argv[2][0]);
26     if (key == -1)
27         printf("File does not exist\n");
28
29     exit(EXIT_SUCCESS);
30 }
