/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 46-5 */

 1 #include <sys/types.h>
 2 #include <sys/msg.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     struct msqid_ds ds;
 9     int msqid;
10
11     if (argc != 3 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s msqid max-bytes\n", argv[0]);
13
14     /* Retrieve copy of associated data structure from kernel */
15
16     msqid = getInt(argv[1], 0, "msqid");
17     if (msgctl(msqid, IPC_STAT, &ds) == -1)
18         errExit("msgctl");
19
20     ds.msg_qbytes = getInt(argv[2], 0, "max-bytes");
21
22     /* Update associated data structure in kernel */
23
24     if (msgctl(msqid, IPC_SET, &ds) == -1)
25         errExit("msgctl");
26
27     exit(EXIT_SUCCESS);
28 }
