/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 48-4 */

 1 #include <sys/types.h>
 2 #include <sys/shm.h>
 3 #include <time.h>
 4 #include "tlpi_hdr.h"
 5
 6 static void
 7 printShmDS(const struct shmid_ds *ds)
 8 {
 9     printf("Size:                      %ld\n", (long) ds->shm_segsz);
10     printf("# of attached processes:   %ld\n", (long) ds->shm_nattch);
11
12     printf("Mode:                      %lo",
13             (unsigned long) ds->shm_perm.mode);
14 #ifdef SHM_DEST
15     printf("%s", (ds->shm_perm.mode & SHM_DEST) ? " [DEST]" : "");
16 #endif
17 #ifdef SHM_LOCKED
18     printf("%s", (ds->shm_perm.mode & SHM_LOCKED) ? " [LOCKED]" : "");
19 #endif
20     printf("\n");
21
22     printf("Last shmat():              %s", ctime(&ds->shm_atime));
23     printf("Last shmdt():              %s", ctime(&ds->shm_dtime));
24     printf("Last change:               %s", ctime(&ds->shm_ctime));
25
26     printf("Creator PID:               %ld\n", (long) ds->shm_cpid);
27     printf("PID of last attach/detach: %ld\n", (long) ds->shm_lpid);
28 }
29
30 int
31 main(int argc, char *argv[])
32 {
33     struct shmid_ds ds;
34
35     if (argc != 2 || strcmp(argv[1], "--help") == 0)
36         usageErr("%s shmid\n", argv[0]);
37
38     if (shmctl(getInt(argv[1], 0, "shmid"), IPC_STAT, &ds) == -1)
39         errExit("shmctl");
40
41     printShmDS(&ds);
42
43     exit(EXIT_SUCCESS);
44 }
