/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 12-2 */

 1 #ifdef __linux__
 2 #define _GNU_SOURCE
 3 #endif
 4 #include <sys/utsname.h>
 5 #include "tlpi_hdr.h"
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     struct utsname uts;
11
12     if (uname(&uts) == -1)
13         errExit("uname");
14
15     printf("Node name:   %s\n", uts.nodename);
16     printf("System name: %s\n", uts.sysname);
17     printf("Release:     %s\n", uts.release);
18     printf("Version:     %s\n", uts.version);
19     printf("Machine:     %s\n", uts.machine);
20 #ifdef _GNU_SOURCE
21     printf("Domain name: %s\n", uts.domainname);
22 #endif
23     exit(EXIT_SUCCESS);
24 }
