/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 29-2 */

 1 #include <pthread.h>
 2 #include "tlpi_hdr.h"
 3
 4 static void *
 5 threadFunc(void *x)
 6 {
 7     return x;
 8 }
 9
10 int
11 main(int argc, char *argv[])
12 {
13     pthread_t thr;
14     pthread_attr_t attr;
15     int s;
16
17     s = pthread_attr_init(&attr);       /* Assigns default values */
18     if (s != 0)
19         errExitEN(s, "pthread_attr_init");
20
21     s = pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
22     if (s != 0)
23         errExitEN(s, "pthread_attr_setdetachstate");
24
25     s = pthread_create(&thr, &attr, threadFunc, (void *) 1);
26     if (s != 0)
27         errExitEN(s, "pthread_create");
28
29     s = pthread_attr_destroy(&attr);    /* No longer needed */
30     if (s != 0)
31         errExitEN(s, "pthread_attr_destroy");
32
33     s = pthread_join(thr, NULL);
34     if (s != 0)
35         errExitEN(s, "pthread_join failed as expected");
36
37     exit(EXIT_SUCCESS);
38 }
