/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 29-1 */

 1 #include <pthread.h>
 2 #include "tlpi_hdr.h"
 3
 4 static void *
 5 threadFunc(void *arg)
 6 {
 7     char *s = (char *) arg;
 8
 9     printf("%s", s);
10
11     return (void *) strlen(s);
12 }
13
14 int
15 main(int argc, char *argv[])
16 {
17     pthread_t t1;
18     void *res;
19     int s;
20
21     s = pthread_create(&t1, NULL, threadFunc, "Hello world\n");
22     if (s != 0)
23         errExitEN(s, "pthread_create");
24
25     printf("Message from main()\n");
26     s = pthread_join(t1, &res);
27     if (s != 0)
28         errExitEN(s, "pthread_join");
29
30     printf("Thread returned %ld\n", (long) res);
31
32     exit(EXIT_SUCCESS);
33 }
