/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 31-1 */

 1 #define _GNU_SOURCE                 /* Get '_sys_nerr' and '_sys_errlist'
 2                                        declarations from <stdio.h> */
 3 #include <stdio.h>
 4 #include <string.h>                 /* Get declaration of strerror() */
 5
 6 #define MAX_ERROR_LEN 256           /* Maximum length of string
 7                                        returned by strerror() */
 8
 9 static char buf[MAX_ERROR_LEN];     /* Statically allocated return buffer */
10
11 char *
12 strerror(int err)
13 {
14     if (err < 0 || err >= _sys_nerr || _sys_errlist[err] == NULL) {
15         snprintf(buf, MAX_ERROR_LEN, "Unknown error %d", err);
16     } else {
17         strncpy(buf, _sys_errlist[err], MAX_ERROR_LEN - 1);
18         buf[MAX_ERROR_LEN - 1] = '\0';          /* Ensure null termination */
19     }
20
21     return buf;
22 }
