/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 31-2 */

 1 #include <stdio.h>
 2 #include <string.h>                 /* Get declaration of strerror() */
 3 #include <pthread.h>
 4 #include "tlpi_hdr.h"
 5
 6 static void *
 7 threadFunc(void *arg)
 8 {
 9     char *str;
10
11     printf("Other thread about to call strerror()\n");
12     str = strerror(EPERM);
13     printf("Other thread: str (%p) = %s\n", str, str);
14
15     return NULL;
16 }
17
18 int
19 main(int argc, char *argv[])
20 {
21     pthread_t t;
22     int s;
23     char *str;
24
25     str = strerror(EINVAL);
26     printf("Main thread has called strerror()\n");
27
28     s = pthread_create(&t, NULL, threadFunc, NULL);
29     if (s != 0)
30         errExitEN(s, "pthread_create");
31
32     s = pthread_join(t, NULL);
33     if (s != 0)
34         errExitEN(s, "pthread_join");
35
36     printf("Main thread:  str (%p) = %s\n", str, str);
37
38     exit(EXIT_SUCCESS);
39 }
