/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 32-1 */

 1 #include <pthread.h>
 2 #include "tlpi_hdr.h"
 3
 4 static void *
 5 threadFunc(void *arg)
 6 {
 7     int j;
 8
 9     printf("New thread started\n");     /* May be a cancellation point */
10     for (j = 1; ; j++) {
11         printf("Loop %d\n", j);         /* May be a cancellation point */
12         sleep(1);                       /* A cancellation point */
13     }
14
15     /* NOTREACHED */
16     return NULL;
17 }
18
19 int
20 main(int argc, char *argv[])
21 {
22     pthread_t thr;
23     int s;
24     void *res;
25
26     s = pthread_create(&thr, NULL, threadFunc, NULL);
27     if (s != 0)
28         errExitEN(s, "pthread_create");
29
30     sleep(3);                           /* Allow new thread to run a while */
31
32     s = pthread_cancel(thr);
33     if (s != 0)
34         errExitEN(s, "pthread_cancel");
35
36     s = pthread_join(thr, &res);
37     if (s != 0)
38         errExitEN(s, "pthread_join");
39
40     if (res == PTHREAD_CANCELED)
41         printf("Thread was canceled\n");
42     else
43         printf("Thread was not canceled (should not happen!)\n");
44
45     exit(EXIT_SUCCESS);
46 }
