/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 30-1 */

 1 #include <pthread.h>
 2 #include "tlpi_hdr.h"
 3
 4 static volatile int glob = 0;   /* "volatile" prevents compiler optimizations
 5                                    of arithmetic operations on 'glob' */
 6 static void *                   /* Loop 'arg' times incrementing 'glob' */
 7 threadFunc(void *arg)
 8 {
 9     int loops = *((int *) arg);
10     int loc, j;
11
12     for (j = 0; j < loops; j++) {
13         loc = glob;
14         loc++;
15         glob = loc;
16     }
17
18     return NULL;
19 }
20
21 int
22 main(int argc, char *argv[])
23 {
24     pthread_t t1, t2;
25     int loops, s;
26
27     loops = (argc > 1) ? getInt(argv[1], GN_GT_0, "num-loops") : 10000000;
28
29     s = pthread_create(&t1, NULL, threadFunc, &loops);
30     if (s != 0)
31         errExitEN(s, "pthread_create");
32     s = pthread_create(&t2, NULL, threadFunc, &loops);
33     if (s != 0)
34         errExitEN(s, "pthread_create");
35
36     s = pthread_join(t1, NULL);
37     if (s != 0)
38         errExitEN(s, "pthread_join");
39     s = pthread_join(t2, NULL);
40     if (s != 0)
41         errExitEN(s, "pthread_join");
42
43     printf("glob = %d\n", glob);
44     exit(EXIT_SUCCESS);
45 }
