/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 10-3 */

 1 #define _XOPEN_SOURCE
 2 #include <time.h>
 3 #include <locale.h>
 4 #include "tlpi_hdr.h"
 5
 6 #define SBUF_SIZE 1000
 7
 8 int
 9 main(int argc, char *argv[])
10 {
11     struct tm tm;
12     char sbuf[SBUF_SIZE];
13     char *ofmt;
14
15     if (argc < 3 || strcmp(argv[1], "--help") == 0)
16         usageErr("%s input-date-time in-format [out-format]\n", argv[0]);
17
18     if (setlocale(LC_ALL, "") == NULL)
19         errExit("setlocale");   /* Use locale settings in conversions */
20
21     memset(&tm, 0, sizeof(struct tm));          /* Initialize 'tm' */
22     if (strptime(argv[1], argv[2], &tm) == NULL)
23         fatal("strptime");
24
25     tm.tm_isdst = -1;           /* Not set by strptime(); tells mktime()
26                                    to determine if DST is in effect */
27     printf("calendar time (seconds since Epoch): %ld\n", (long) mktime(&tm));
28
29     ofmt = (argc > 3) ? argv[3] : "%H:%M:%S %A, %d %B %Y %Z";
30     if (strftime(sbuf, SBUF_SIZE, ofmt, &tm) == 0)
31         fatal("strftime returned 0");
32     printf("strftime() yields: %s\n", sbuf);
33
34     exit(EXIT_SUCCESS);
35 }
