/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 62-1 */

 1 #include <termios.h>
 2 #include <ctype.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     struct termios tp;
 9     int intrChar;
10
11     if (argc > 1 && strcmp(argv[1], "--help") == 0)
12         usageErr("%s [intr-char]\n", argv[0]);
13
14     /* Determine new INTR setting from command line */
15
16     if (argc == 1) {                                    /* Disable */
17         intrChar = fpathconf(STDIN_FILENO, _PC_VDISABLE);
18         if (intrChar == -1)
19             errExit("Couldn't determine VDISABLE");
20     } else if (isdigit((unsigned char) argv[1][0])) {
21         intrChar = strtoul(argv[1], NULL, 0);           /* Allows hex, octal */
22     } else {                                            /* Literal character */
23         intrChar = argv[1][0];
24     }
25
26     /* Fetch current terminal settings, modify INTR character, and
27        push changes back to the terminal driver */
28
29     if (tcgetattr(STDIN_FILENO, &tp) == -1)
30         errExit("tcgetattr");
31     tp.c_cc[VINTR] = intrChar;
32     if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &tp) == -1)
33         errExit("tcsetattr");
34
35     exit(EXIT_SUCCESS);
36 }
