/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 62-2 */

 1 #include <termios.h>
 2 #include "tlpi_hdr.h"
 3
 4 #define BUF_SIZE 100
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     struct termios tp, save;
10     char buf[BUF_SIZE];
11
12     /* Retrieve current terminal settings, turn echoing off */
13
14     if (tcgetattr(STDIN_FILENO, &tp) == -1)
15         errExit("tcgetattr");
16     save = tp;                          /* So we can restore settings later */
17     tp.c_lflag &= ~ECHO;                /* ECHO off, other bits unchanged */
18     if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &tp) == -1)
19         errExit("tcsetattr");
20
21     /* Read some input and then display it back to the user */
22
23     printf("Enter text: ");
24     fflush(stdout);
25     if (fgets(buf, BUF_SIZE, stdin) == NULL)
26         printf("Got end-of-file/error on fgets()\n");
27     else
28         printf("\nRead: %s", buf);
29
30     /* Restore original terminal settings */
31
32     if (tcsetattr(STDIN_FILENO, TCSANOW, &save) == -1)
33         errExit("tcsetattr");
34
35     exit(EXIT_SUCCESS);
36 }
